/*****************************************************************************************************

	Coded Februar 2012 -- by -- Vincent Roch

*****************************************************************************************************/


#include "StartGetSAM.h"
HWND hControlDialog;

int APIENTRY WinMain(HINSTANCE hProg,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow){
char buffer[1024];
LPTSTR lpbuf = buffer;

//User interface
MSG Message;
WNDCLASS Wc;
HINSTANCE hInstance;
HWND hWnd;

	Wc.cbClsExtra = 0;
	Wc.cbWndExtra = 0;
	Wc.hbrBackground = CreateSolidBrush(0x00BB0000);
	Wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	Wc.hIcon = LoadIcon(hInstance, IDI_APPLICATION);
	Wc.hInstance = hInstance;
	Wc.lpfnWndProc = (WNDPROC)MainProc;
	Wc.lpszClassName = "WindowClass";
	Wc.style = CS_HREDRAW | CS_VREDRAW;

	if(!RegisterClass(&Wc))
		return 0;
	    
	hInstance = hProg;
	hWnd = CreateDialog(hInstance, "MAIN", NULL, (DLGPROC)MainProc);
	
	ShowWindow(hWnd, SW_SHOWNORMAL);
	UpdateWindow(hWnd);

	while(GetMessage(&Message, NULL, 0, 0)>0){
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
	
}

BOOL CALLBACK MainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
char path[256], szString2Hash[256];
LPTSTR lpLogFilePath = path;
LPTSTR lpString2Hash = szString2Hash;

HWND hWndOwner;
RECT rectowner, rectchild;
int xmiddleowner, xmiddlechild, ymiddleowner, ymiddlechild, x, y;

  switch(uMsg){
	case WM_CLOSE:
	case WM_DESTROY:
			PostQuitMessage(0);
		return(1);
    break;
	case WM_INITDIALOG:

		hControlDialog = hWnd;

		hWndOwner = GetDesktopWindow();
        GetWindowRect(hWndOwner, &rectowner);
        GetWindowRect(hWnd, &rectchild);
		xmiddleowner = (rectowner.right + rectowner.left)/2;
		xmiddlechild = (rectchild.right + rectchild.left)/2;
		x = xmiddleowner - xmiddlechild;
		ymiddleowner = (rectowner.bottom + rectowner.top)/2;
		ymiddlechild = (rectchild.bottom + rectchild.top)/2;
		y = ymiddleowner - ymiddlechild;
        SetWindowPos(hWnd, HWND_TOP, x, y, 0, 0,SWP_NOSIZE);
		
		return(TRUE);
		break;
	
	case WM_COMMAND:
			switch(LOWORD(wParam)){
			
			case BTN_QUIT:
				SendMessage(hWnd, WM_DESTROY, 0, 0);
			break;
			case BTN_START:
				GetCurrentDirectory(256, lpLogFilePath);
				lstrcat(lpLogFilePath, "\\LogFile.txt");
				StartServiceRoutine(lpLogFilePath);
			break;
			case BTN_REMOVE:
				RemoveServiceRoutine();
			break;
			case BTN_STOP:
				StopServiceRoutine();
			break;
			case ID_GEN:
				GetDlgItemText(hWnd, EDIT_MD4, lpString2Hash, 256);
				if (lstrlen(lpString2Hash) < 256)
					GenerateMD4Hash(lpString2Hash);
			break;

		}//end switch
		break;
	default:
		return(FALSE);
	}
	return(TRUE);
}
void StartServiceRoutine(LPTSTR Path2LogFile){
SC_HANDLE schSCManager, schService;
OPENFILENAME ofn;

char buffer[1024], path2Service[256], szFile1[256];
LPTSTR lpbuf = buffer;
LPTSTR lppath2Service = path2Service;

	schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if (schSCManager == NULL){
		MessageBox(NULL, "OpenSCM", "Error", MB_OK);
		return;}
	
	//Open / Create the service
	schService = OpenService(schSCManager, "GetSAM", SC_MANAGER_ALL_ACCESS);

	if (!schService){
		//We have to get the path to the service executable
		ZeroMemory(&ofn, sizeof(OPENFILENAME));
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = (HWND)NULL;
		ofn.lpstrFile = szFile1;
		ofn.nMaxFile = 256;
		ofn.lpstrFilter = "All\0*.*\0exe\0*.EXE\0";
		ofn.nFilterIndex = 1;
		ofn.lpstrFileTitle = NULL;
		ofn.nMaxFileTitle = 0;
		ofn.lpstrInitialDir = NULL;
		ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	if (GetOpenFileName(&ofn))lstrcpy(lppath2Service, ofn.lpstrFile);
	else {
		MessageBox(NULL, "Please select the service exe", "Error", MB_OK);
		return;
	}

		schService = CreateService(schSCManager, "GetSAM", "GetSAM", SC_MANAGER_ALL_ACCESS, 
			SERVICE_WIN32_OWN_PROCESS, 
			SERVICE_DEMAND_START, SERVICE_ERROR_IGNORE, lppath2Service, 
			NULL, NULL, NULL, "NT AUTHORITY\\SYSTEM", NULL);
		if (schService == NULL){
			FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), 
					MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), lpbuf, 1024, NULL);
			MessageBox(NULL, lpbuf, "Error creating Service", MB_OK);
		}
		else {
			if (!StartService(schService, 1, &Path2LogFile)){
			FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), 
					MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), lpbuf, 1024, NULL);
			MessageBox(NULL, lpbuf, "Error service start", MB_OK);
			}
			else MessageBox(NULL, "Service started", "Success", MB_OK);
		}
	}
	else {

		if (!StartService(schService, 1, &Path2LogFile)){
			FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), 
					MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), lpbuf, 1024, NULL);
			MessageBox(NULL, lpbuf, "Error service start", MB_OK);
		}
		else MessageBox(NULL, "Service started", "Success", MB_OK);

	}

	CloseServiceHandle(schService);
	CloseServiceHandle(schSCManager);

	


return;

}

void RemoveServiceRoutine(){
SC_HANDLE schSCManager, schService;
SERVICE_STATUS ServiceStatus;

	schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if (schSCManager == NULL){
		MessageBox(NULL, "OpenSCM", "Error", MB_OK);
		return;}

	schService = OpenService(schSCManager, "GetSAM", SC_MANAGER_ALL_ACCESS);
	if (!schService){
		MessageBox(NULL, "Unable to open the service", "Error", MB_OK);
		CloseServiceHandle(schSCManager);
		return;
	}

	ControlService(schService, SERVICE_CONTROL_STOP, &ServiceStatus);

	if (!DeleteService(schService))MessageBox(NULL, "Unable to remove the service", 
		"Error", MB_OK);
	else MessageBox(NULL, "Service removed", "Success", MB_OK);

	CloseServiceHandle(schService);
	CloseServiceHandle(schSCManager);

return;
}
void StopServiceRoutine(){
SC_HANDLE schSCManager, schService;
SERVICE_STATUS ServiceStatus;

	schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if (schSCManager == NULL){
		MessageBox(NULL, "OpenSCM", "Error", MB_OK);
		return;}

	//Stop the service
	schService = OpenService(schSCManager, "GetSAM", SC_MANAGER_ALL_ACCESS);
	if (!schService){
		MessageBox(NULL, "Unable to open the service", "Error", MB_OK);
		CloseServiceHandle(schSCManager);
		return;
	}

	if (ControlService(schService, SERVICE_CONTROL_STOP, &ServiceStatus))
		MessageBox(NULL, "Service stopped", "Success", MB_OK);
	else {
		if (ServiceStatus.dwCurrentState == SERVICE_STOPPED)
			MessageBox(NULL, "Service not running", "Info", MB_OK);
		else MessageBox(NULL, "Unable to stop service", "Error", MB_OK);
	}


	CloseServiceHandle(schService);
	CloseServiceHandle(schSCManager);

return;
}
void GenerateMD4Hash(LPTSTR szString2Hash){
HCRYPTPROV hCryptProv = (ULONG_PTR)NULL; 
HCRYPTHASH hHash;
DWORD dwError, i;

char buffer[256];
LPTSTR lpbuf = buffer;

BYTE *HexHash, *WideInputString;

BYTE HashData[256];
DWORD dwHashDataLen = 256;


	if (lstrlen(szString2Hash)){
		WideInputString = (PBYTE)VirtualAlloc(NULL, 2*lstrlen(szString2Hash), MEM_COMMIT | MEM_RESERVE, 
							PAGE_READWRITE);

		if (!WideInputString){
			MessageBox(NULL, "Memory allocation", "Error", MB_OK);
			return;
		}
	
		//Convert to Unicode String-like
		for (i = 0; i < 2*lstrlen(szString2Hash); i++){
			WideInputString[2*i] = szString2Hash[i];
		}
	}

	if(!CryptAcquireContext(&hCryptProv, NULL, NULL, PROV_RSA_FULL, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		MessageBox(NULL, lpbuf, "Error Acquire Ctxt", MB_OK);
		if (WideInputString)VirtualFree(WideInputString, 0, MEM_RELEASE);
		return;
		}

	if (!CryptCreateHash(hCryptProv, CALG_MD4, 0, 0, &hHash)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		MessageBox(NULL, lpbuf, "Error Creating hash", MB_OK);
		if (hCryptProv)CryptReleaseContext(hCryptProv, 0);
		if (WideInputString)VirtualFree(WideInputString, 0, MEM_RELEASE);
		return;
		}

	//If empty input
	if (!lstrlen(szString2Hash)){
		if (!CryptHashData(hHash, "", 0, 0)){
			dwError = GetLastError();
			wsprintf(lpbuf, "%x", dwError);
			MessageBox(NULL, lpbuf, "Error Creating hash", MB_OK);
			if (hHash)CryptDestroyHash(hHash);
			if (hCryptProv)CryptReleaseContext(hCryptProv, 0);
			if (WideInputString)VirtualFree(WideInputString, 0, MEM_RELEASE);
			return;
		}
	}
	else {
		if (!CryptHashData(hHash, WideInputString, 2*lstrlen(szString2Hash), 0)){
			dwError = GetLastError();
			wsprintf(lpbuf, "%x", dwError);
			MessageBox(NULL, lpbuf, "Error Creating hash", MB_OK);
			if (hHash)CryptDestroyHash(hHash);
			if (hCryptProv)CryptReleaseContext(hCryptProv, 0);
			if (WideInputString)VirtualFree(WideInputString, 0, MEM_RELEASE);
			return;
		}
	}

	if (!CryptGetHashParam(hHash, HP_HASHVAL, HashData, &dwHashDataLen, 0)){
		dwError = GetLastError();
		wsprintf(lpbuf, "%x", dwError);
		MessageBox(NULL, lpbuf, "Error Creating hash", MB_OK);
		if (hHash)CryptDestroyHash(hHash);
		if (hCryptProv)CryptReleaseContext(hCryptProv, 0);
		if (WideInputString)VirtualFree(WideInputString, 0, MEM_RELEASE);
		return;
	}

	else {
		HexHash = (PBYTE)VirtualAlloc(NULL, 2*dwHashDataLen + 1, MEM_COMMIT | MEM_RESERVE, 
						PAGE_READWRITE);
		if (!HexHash){
			MessageBox(NULL, "Memory allocation", "Error", MB_OK);
			if (hHash)CryptDestroyHash(hHash);
			if (hCryptProv)CryptReleaseContext(hCryptProv, 0);
			if (WideInputString)VirtualFree(WideInputString, 0, MEM_RELEASE);
			return;
		}
		Convert2Hex(HashData, dwHashDataLen, HexHash);
		SetDlgItemText(hControlDialog, OUTPUT_MD4, HexHash);
	}
		


	if (hHash)CryptDestroyHash(hHash);
	if (hCryptProv)CryptReleaseContext(hCryptProv, 0);
	if (HexHash)VirtualFree(HexHash, 0, MEM_RELEASE);
	if (WideInputString)VirtualFree(WideInputString, 0, MEM_RELEASE);


return;
}

//Convert ascii to hex (from MSDN)
void Convert2Hex(BYTE *HashData, DWORD dwHashDataLen, BYTE *HexHash){
DWORD Counter;
char *strHash;
char *hex = "0123456789abcdef";

	for(Counter = 0; Counter < dwHashDataLen; Counter++){
			HexHash[Counter*2]     = hex[HashData[Counter] >> 4];
			HexHash[(Counter*2)+1] = hex[HashData[Counter] & 0xF];
		}

return;
}